# All files / src/custom-nodes AbstractCustomNodeGroup.ts

100% Statements 10/10
100% Branches 0/0
100% Functions 2/2
100% Lines 10/10

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    571x
    1x

    1x

    1x
    1x

    8015x

    8015x

    1044x
    2602x

    1044x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from '../container/ServiceIdentifiers';

    import { TObfuscationEvent } from '../types/event-emitters/TObfuscationEvent';

    import { ICustomNode } from '../interfaces/custom-nodes/ICustomNode';
    import { ICustomNodesFactory } from '../interfaces/custom-nodes/ICustomNodesFactory';
    import { IOptions } from '../interfaces/options/IOptions';
    import { IStackTraceData } from '../interfaces/stack-trace-analyzer/IStackTraceData';

    import { ObfuscationEvents } from '../enums/ObfuscationEvents';

    @injectable()
    export abstract class AbstractCustomNodesFactory implements ICustomNodesFactory {
        /**
         * @type {TObfuscationEvent}
         */
        protected readonly appendEvent: TObfuscationEvent = ObfuscationEvents.BeforeObfuscation;

        /**
         * @type {IStackTraceData[]}
         */
        protected readonly stackTraceData: IStackTraceData[];

        /**
         * @type {IOptions}
         */
        protected readonly options: IOptions;

        /**
         * @param options
         */
        constructor (
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            this.options = options;
        }

        /**
         * @param stackTraceData
         * @returns {Map<string, ICustomNode> | undefined}
         */
        public abstract initializeCustomNodes (stackTraceData: IStackTraceData[]): Map <string, ICustomNode> | undefined;

        /**
         * @param customNodes
         * @returns {Map<string, ICustomNode>}
         */
        protected syncCustomNodesWithNodesFactory (customNodes: Map <string, ICustomNode>): Map <string, ICustomNode> {
            customNodes.forEach((customNode: ICustomNode) => {
                customNode.setAppendEvent(this.appendEvent);
            });

            return customNodes;
        }
    }